'''
   We have four players competing in Scrabble+. In each hand
   of Scrabble+, players, in turn, have to enter a word in the
   scoreboard, getting a score that depends on the value
   of the letters composing the inserted word.

   Each player creates his own word by choosing it from a
   hand of 8 tiles, which are replaced once the word
   has been played until they are exhausted. The total number of
   tiles is 130.  The game ends when a player manages to
   finish all the tiles in his hand and there are no more tiles available
   to replace those just played: this happens because
   all the tiles are in the scoreboard and in the hand of
   the other players.

   At the end of the game, the player with the highest score wins,
   considering that for each tile that remains unplayed
   (i.e. it remains in a player's hand when the game ends)
   3 points are subtracted.
   The scores are calculated as follows:
   1 point:  E, A, I, O, N, R, T, L, S, U
   2 points: D, G
   3 points: B, C, M, P
   4 points: F, H, V, W, Y
   5 points: K
   8 points: J, X
  10 points: Q , Z

   Design a function es1(g1, g2, g3, g4, tiles, hand_tiles) that returns the
   scores of a game of Scrabble+ played among the 4 players, with
   the variant that the number of initial letters is "tiles", rather than
   130 and the number of letters available to each player is "hand_tiles".
   g1, g2, g3 and g4 are lists of strings that contain the sequence of
   words inserted by player 1, player 2, player 3 and player 4,
   respectively, in each turn.

ES: hand_tiles=5, tiles=40
    g1 = ['seta','peeks','deter']
    g2 = ['reo','pumas']
    g3 = ['xx','xx']
    g4 = ['frs','bern']

hand_tiles - tiles - word - score
5 5 5 5       20    seta    4 0 0 0
5 5 5 5       16    reo     4 3 0 0
5 5 5 5       13    xx      4 3 16 0
5 5 5 5       11    frs     4 3 16 6
5 5 5 5       8     peeks  15 3 16 6
5 5 5 5       3     pumas  15 12 16 6
5 3 5 5       0     xx     15 12 32 6
5 3 3 5       0     bern   15 12 32 12
5 3 3 1       0     deter  21 12 32 12
0 3 3 1       0     GAME OVER
--------------------------------------
Final score                21 3 23 9
 '''

#VALUES = {'A':1, 'C':1, 'E':1, 'I':1, 'O':1, 'R':1, 'S':1, 'T':1,
#          'a':1, 'c':1, 'e':1, 'i':1, 'o':1, 'r':1, 's':1, 't':1,
#          'L':2, 'M':2, 'N':2, 'l':2, 'm':2, 'n':2,
#          'P':3, 'p':3,
#          'B':4, 'D':4, 'F':4, 'G':4, 'U':4, 'V':4,
#          'b':4, 'd':4, 'f':4, 'g':4, 'u':4, 'v':4,
#          'H':8, 'Z':8, 'h':8, 'z':8,
#          'Q':10, 'q':10}

DEBUG = False

class color:
   PURPLE = '\033[95m'
   CYAN = '\033[96m'
   DARKCYAN = '\033[36m'
   BLUE = '\033[94m'
   GREEN = '\033[92m'
   YELLOW = '\033[93m'
   RED = '\033[91m'
   BOLD = '\033[1m'
   UNDERLINE = '\033[4m'
   END = '\033[0m'

VALUES = [0]*128

for c in 'AaEeIiOoNnRrTtLlSsUu':
    VALUES[ord(c)] = 1
for c in 'DdGg':
    VALUES[ord(c)] = 2
for c in 'BbCcMmPp':
    VALUES[ord(c)] = 3
for c in 'FfHhVvWwYy':
    VALUES[ord(c)] = 4
for c in 'Kk':
    VALUES[ord(c)] = 5
for c in 'JjXx':
    VALUES[ord(c)] = 8
for c in 'QqZz':
    VALUES[ord(c)] = 10


def evaluate(word):
    value = 0
    for char in word:
        try:
            value += VALUES[ord(char)]
        except:
            print(f"il carattere '{char}' non è conosciuto")
            raise
    return value


def ex1(g1, g2, g3, g4, m, n):
    # Insert here your code
    pass
    tiles = [m] * 4
    unused_tiles = n - m * 4
    hands = (g1, g2, g3, g4)
    points = [0] * 4
    turn = 0
    player = 0
    while unused_tiles > 0:
        player = turn % 4
        points[player] += evaluate(hands[turn %4][turn //4])
        if unused_tiles <= len(hands[turn %4][turn //4]):
            tiles[player] = m - len(hands[turn%4][turn//4]) + unused_tiles
            unused_tiles = 0
            # if DEBUG: print("Turn:", turn, 'player:', turn%4, 'word number:', turn//4, 'word:', color.BOLD+color.RED+hands[turn%4][turn//4]+color.END)
            # if DEBUG: print("Hand tiles:", tiles, 'unused_tiles:', unused_tiles)
            # if DEBUG: print("Points:", points)
            break
        unused_tiles -= len(hands[turn%4][turn//4])
        # if DEBUG: print("Turn:", turn, 'player:', turn%4, 'word number:', turn//4, 'word:', color.BOLD+color.RED+hands[turn%4][turn//4]+color.END)
        # if DEBUG: print("Tiles:", tiles, 'unused_tiles:', unused_tiles)
        # if DEBUG: print("Points:", points)
        turn += 1
    # if DEBUG: print('Unused_tiles are over')
    while tiles[player] != 0:
        turn += 1
        player = turn % 4
        points[player] += evaluate(hands[turn %4][turn //4])
        tiles[player] -= len(hands[turn%4][turn//4])
        # if DEBUG: print("Turn:", turn, 'player:', turn%4, 'word number:', turn//4, 'word:', color.BOLD+color.RED+hands[turn%4][turn//4]+color.END)
        # if DEBUG: print("Tiles:", tiles, 'unused_tiles:', unused_tiles)
        # if DEBUG: print("Points:", points)
    for player, unused_tiles in enumerate(tiles):
        points[player] -= 3 * unused_tiles
    return points


if __name__ == "__main__":
    g1 = ['seta','peeks','deter']
    g2 = ['reo','pumas']
    g3 = ['xx','xx']
    g4 = ['frs','bern']
    print(ex1(g1, g2, g3, g4, 5, 40))
